{
  description = "learning Common Lisp";

  outputs = { self, nixpkgs, flake-utils }:
    flake-utils.lib.eachDefaultSystem
      (system:
        let pkgs = nixpkgs.legacyPackages.${system}; in
        {
          devShells.default = pkgs.mkShell {
            buildInputs = [
              pkgs.sbcl

              # for koans
              pkgs.inotify-tools

              # for CLOG
              pkgs.openssl
              pkgs.sqlite
            ];
            shellHook = ''
              export LD_LIBRARY_PATH=${pkgs.lib.makeLibraryPath([pkgs.openssl])}:${pkgs.lib.makeLibraryPath([pkgs.sqlite])}
            '';
          };
        }
      );
  # see https://serokell.io/blog/practical-nix-flakes

  # welp, I would be able to reference store paths here, yup
  # but what's the actual way to do that?
}
